package com.smppw.modaq.application.task;

import cn.hutool.core.date.DateUtil;
import com.smppw.modaq.application.service.EmailParseApiService;
import jakarta.annotation.PostConstruct;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
@EnableScheduling
public class ParseSchedulerTask {
    private final EmailParseApiService emailParseApiService;

    public ParseSchedulerTask(EmailParseApiService emailParseApiService) {
        this.emailParseApiService = emailParseApiService;
    }

    @PostConstruct
    public void executeOnStartup() {
        this.run();
    }

    /**
     * 定时任务每2小时执行一次
     */
    @Scheduled(cron = "0 0 */2 * * ?")
    public void run() {
        Date preDay = DateUtil.offsetMinute(new Date(), -121);
        this.emailParseApiService.parseEmail(preDay, new Date());
    }
}
